
Require Import ZArith.
Require Import Arith.
Open Scope Z_scope.
Inductive Z_btree: Set := 
Z_leaf: Z_btree | Z_bnode: Z-> Z_btree-> Z_btree ->Z_btree.

Print Z_btree_ind.
Check Z_btree_ind.

Fixpoint sum_all_values (t:Z_btree) : Z :=
(match t with 
| Z_leaf => 0
| Z_bnode v t1 t2 => v + sum_all_values t1 +   sum_all_values t2
end)%Z.
 
Fixpoint zero_values (t:Z_btree): bool:=
match t with
|Z_leaf => false
|Z_bnode (0%Z) t1 t2 => true 
|Z_bnode _ t1 t2 => if zero_values t1 then true else zero_values t2
end.


Eval compute in (sum_all_values (Z_leaf)).

Eval compute in (sum_all_values (Z_bnode 1 (Z_bnode 2 Z_leaf Z_leaf) Z_leaf)).